#include <stdio.h>
#include <string.h>
#include <translat.h>
#include "ldapconf.h"
#include "ldapconf.m"
#include <subsys.h>
#include <configf.h>
#include <userconf.h>
#include <fviews.h>
#include <string.h>

const char PAM_SERVICES[]="/etc/pam.d";
const char PAM_MODULES[]="/lib/security";
const char LDAP_DATA_DIR[]="/var/ldap";
const char LDAP_CONF_DIR[]="/etc/ldap";
const char subsys_ldap[]="ldap";

extern HELP_FILE help_ldap;

extern PRIVILEGE p_ldap;
extern LINUXCONF_SUBSYS subb;

extern CONFIG_FILE f_slapd_conf;
extern CONFIG_FILE f_ldap_conf;
extern CONFIG_FILE f_ldap_sec;
extern CONFIG_FILE f_nss_conf;

class LDAPPROFILE: public ARRAY_OBJ {
public:
	SSTRING host;
	SSTRING port;
	SSTRING dn;
	SSTRING pw;
	SSTRING base;
	SSTRING scope;
	SSTRING filter;
	SSTRING attr;
	SSTRING db_type;
	SSTRING db_dir;
	SSTRING db_replog;

	/*~PROTOBEG~ LDAPPROFILE */
public:
	LDAPPROFILE (void);
	void default_dialog (void);
	/*~PROTOEND~ LDAPPROFILE */
};

class LDAPDB: public ARRAY_OBJ {
public:
	LDAPPROFILE bind;
	char	*name;		/* DB nickname */
	SSTRING database;	/* Database type */
	SSTRING directory;	/* Data directory */
	SSTRING replogfile;	/* Replication log */
	SSTRING updatedn;
	SSTRING replica;	
	SSTRING lastmod;
	SSTRING readonly;
	SSTRINGS access_list;
	SSTRINGS attribute_list;
	SSTRINGS objectclass_list;
	SSTRINGS index_list;
	SSTRING defaultaccess;
	SSTRING loglevel;
	SSTRING schemacheck;
	SSTRING referal;
	
	/*~PROTOBEG~ LDAPDB */
public:
	LDAPDB (const char *dbname);
	LDAPDB (void);
	void config (const char *fname);
	int export_ldif (void);
	int import_ldif (void);
	void menu (void);
	/*~PROTOEND~ LDAPDB */
};

class LDAPOBJECT: public ARRAY_OBJ {
public:
	LDAPPROFILE bind;
	SSTRING dn;
	SSTRING host;
	SSTRING port;
	SSTRING binddn;
	SSTRING bindpw;
	SSTRING base;
	SSTRING scope;
	SSTRING filter;
	SSTRING attr;
	SSTRINGS attributes;
	SSTRINGS objectclasses;
	char ldif_format;

	/*~PROTOBEG~ LDAPOBJECT */
public:
	LDAPOBJECT (void);
	int add (void);
	int at_del (const char *at_key);
	char *at_get (const char *var);
	int at_list (SSTRINGS&lst);
	void at_set (const char *var, const char *val);
	int del (void);
	SSTRING *locateassign (const char *var);
	int modify (void);
	int oc_add (const char *oc);
	int oc_del (const char *oc);
	int oc_list (SSTRINGS&lst);
	int search (void);
	int search_list (SSTRINGS&lst);
	/*~PROTOEND~ LDAPOBJECT */
};
