/*********** 

LDAPCONF tools (using ldapapi)

************/

#include "ldap.h"

/*
	LDAPsearch
*/
void ldapsearch()
{

LDAPOBJECT lc; /* LDAP client object */

/* default */

	int ret = 0;
	int nof = 0;

/* Draw dialog */

	DIALOG *dia = NULL;
	while (1) {
		dia = new DIALOG;
		dia->newf_str (MSG_U(F_API_FILTER,"Filter"),lc.filter);
		dia->newf_str (MSG_U(F_API_ATTR,"Show attributes"),lc.attr);	
		dia->newf_chk (MSG_U(F_LDIF_FORMAT,"LDIF format"),lc.ldif_format,"");	
		dia->newf_title ("",MSG_U(I_LDAPBIND,"Binding"));
		dia->newf_str (MSG_R(F_API_BASE),lc.base);
		dia->newf_str (MSG_R(F_API_HOST),lc.host);
		dia->newf_str (MSG_R(F_API_PORT),lc.port);
		dia->newf_str (MSG_R(F_API_DN),lc.binddn);
		dia->newf_str (MSG_R(F_API_PW),lc.bindpw);	
		dia->newf_title ("",MSG_U(I_LDAPOPTIONS,"Results"));
		dia->newf_str ("DN",lc.dn);
		dia->newf_title ("","Attributes");
	        for (int i=0; i<lc.attributes.getnb(); i++){
	                dia->newf_str ("",*lc.attributes.getitem(i));
	        }
		dia->newf_title ("","Objectclass");
		for (int i=0; i<lc.objectclasses.getnb(); i++){
	                dia->newf_str ("",*lc.objectclasses.getitem(i));
	        }	

		dia->setbutinfo (MENU_USR1,MSG_U(B_SEARCH,"Search")
			,MSG_U(X_SEARCH,"Search"));


		MENU_STATUS code = dia->edit (MSG_U(T_API_OBJECT,"LDAP database client")
			,MSG_U(I_API_OBJECT
				,"This is a small database client for testing of your LDAP system.\n It will use the settings from the LDAP client config by default.\n You may specify other settings here if needed.")				
			,help_ldap
			,nof
			,MENUBUT_USR1|MENUBUT_CANCEL);
/* Exit */
		if (code == MENU_CANCEL || code == MENU_ESCAPE){
		  delete dia;
		  break;
		}
/* Save */
		else if (code == MENU_ACCEPT){
			dia->save();
		}
/* Search */
		else if (code == MENU_USR1){
			dia->save();
			lc.attributes.delall();    /* Zero */
			lc.objectclasses.delall();

			SSTRINGS dnlist;
			ret = lc.search_list(dnlist);

			SSTRING choice;
			ldaplist(dnlist,choice);
			lc.filter.setfrom(choice.get());
			ret = lc.search();
			// ldapedit()
		}
		delete dia;
	}
}

/*
	LDAPedit
*/
void ldapedit()
{
	int ret = 0;
	int nof = 0;
	SSTRING uid="";
	LDAPOBJECT lc; /* LDAP client object */

/* Draw dialog */
	DIALOG *dia;
	while (1) {
		dia = new DIALOG;
		dia->newf_str (MSG_U(F_EDIT_USER,"Username"),uid);		
		dia->newf_title ("",MSG_R(I_LDAPBIND));
		dia->newf_str (MSG_R(F_API_BASE),lc.base);
		dia->newf_str (MSG_R(F_API_HOST),lc.host);
		dia->newf_str (MSG_R(F_API_DN),lc.binddn);
		dia->newf_str (MSG_R(F_API_PW),lc.bindpw);
		dia->newf_title ("",MSG_R(I_LDAPOPTIONS));
		dia->newf_str ("DN",lc.dn);
		dia->newf_title ("","Attributes");
	        for (int i=0; i<lc.attributes.getnb(); i++){
	                dia->newf_str ("",*lc.attributes.getitem(i));
	        }
		dia->newf_title ("","Objectclass");
		for (int i=0; i<lc.objectclasses.getnb(); i++){
	                dia->newf_str ("",*lc.objectclasses.getitem(i));
	        }
/* Wait for dialog */
		dia->setbutinfo (MENU_USR1,MSG_R(B_SEARCH)
			,MSG_R(X_SEARCH));
		dia->setbutinfo (MENU_USR2,MSG_R(B_MOD)
			,MSG_R(X_MOD));

		MENU_STATUS code = dia->edit (MSG_U(T_LDAP_EDIT,"LDAP editor")
			,MSG_U(I_LDAP_EDIT
				,"This is a small database LDAP editor")				
			,help_ldap
			,nof
			,MENUBUT_USR1|MENUBUT_USR2|MENUBUT_CANCEL);

		if (code == MENU_CANCEL || code == MENU_ESCAPE){ /* Exit */
		  delete dia;
		  break;
		} else if (code == MENU_ACCEPT){ /* Save */
		  dia->save();
		} else if (code == MENU_USR1){ /* Search */
			dia->save();
			lc.attributes.delall();    /* Zero */
			lc.objectclasses.delall();
			
			char buf[100];
			sprintf(buf,"uid=%s",uid.get());
			lc.filter.setfrom(buf);
			ret = lc.search();
		} else if (code == MENU_USR2){
			dia->save();
			ret = lc.modify();
		}
		delete dia;
	}
}

/*
	LDAPCLIENT useredit
*/
void ldap_useredit()
{
  LDAPOBJECT lc; /* LDAP client object */
  int ret = 0;
  int nof = 0;
  SSTRING uid="";
  SSTRING base="";
  SSTRING host="";
  SSTRING passwd="";
  SSTRING cn="";
  SSTRING givenname="";
  SSTRING sn="";
  SSTRING o="";
  SSTRING ou="";
  SSTRING mail="";
  SSTRING phone="";
  SSTRING cellphone="";
  SSTRING homephone="";
  SSTRING homeurl="";
  SSTRING telephonenumber="";

/* Draw dialog */
	DIALOG *dia;
	while (1) {
		if (lc.at_get("mail") != NULL) { mail.setfrom(lc.at_get("mail")); }
		if (lc.at_get("givenname") != NULL) { givenname.setfrom(lc.at_get("givenname")); }
		if (lc.at_get("sn") != NULL) { sn.setfrom(lc.at_get("sn")); }
       		if (lc.at_get("phone") != NULL) { phone.setfrom(lc.at_get("phone")); }
		if (lc.at_get("cellphone") != NULL) { cellphone.setfrom(lc.at_get("cellphone")); }
		if (lc.at_get("homephone") != NULL) { homephone.setfrom(lc.at_get("homephone")); }
		if (lc.at_get("homeurl") != NULL) {homeurl.setfrom(lc.at_get("homeurl")); }
		if (lc.at_get("telephonenumber") != NULL) { telephonenumber.setfrom(lc.at_get("telephonenumber")); }
		if (lc.at_get("o") != NULL) { o.setfrom(lc.at_get("o")); }
		if (lc.at_get("ou") != NULL) {ou.setfrom(lc.at_get("ou")); }

		dia = new DIALOG;
		dia->newf_str (MSG_U(F_USERNAME,"Username"),uid);
		dia->newf_str (MSG_U(F_PASSWD,"Password"),lc.bindpw);
		dia->newf_str (MSG_U(F_SERVER,"Server"),lc.host);
		dia->newf_str (MSG_U(F_BASE,"Base"),lc.base);
		dia->newf_title("",MSG_U(F_RESULT,"Result"));
		dia->newf_str(MSG_U(F_MAIL,"email"),mail);
		dia->newf_str(MSG_U(F_GIVENNAME,"Name"),givenname);
		dia->newf_str(MSG_U(F_SN,"Surname"),sn);
		dia->newf_str(MSG_U(F_TELEPHONE,"Telephone"),telephonenumber);
		dia->newf_str(MSG_U(F_PHONE,"Work phone"),phone);
		dia->newf_str(MSG_U(F_HOMEPHONE,"Home phone"),homephone);
		dia->newf_str(MSG_U(F_CELLPHONE,"Cellular phone"),cellphone);
		dia->newf_str(MSG_U(F_HOMEURL,"Homepage URL"),homeurl);
		dia->newf_str(MSG_U(F_O,"Organization"),o);
		dia->newf_str(MSG_U(F_OU,"Department"),ou);

		/*
	        for (int i=0; i<lc.attributes.getnb(); i++){
	                dia->newf_str ("",*lc.attributes.getitem(i));
	        }
		dia->newf_title ("","Objectclass");
		for (int i=0; i<lc.objectclasses.getnb(); i++){
	                dia->newf_str ("",*lc.objectclasses.getitem(i));
	        }
		*/
/* Wait for dialog */
		dia->setbutinfo (MENU_USR1,MSG_R(B_SEARCH)
			,MSG_R(X_SEARCH));
		dia->setbutinfo (MENU_USR2,MSG_U(B_MOD,"Modify")
			,MSG_U(X_MOD,"Modify"));

		MENU_STATUS code = dia->edit (MSG_U(T_USEREDIT,"LDAP userinfo")
			,MSG_U(I_USEREDIT
				,"Use this dialog to update your personal info")				
			,help_ldap
			,nof
			,MENUBUT_USR1|MENUBUT_USR2|MENUBUT_CANCEL);

		if (code == MENU_CANCEL || code == MENU_ESCAPE){ /* Exit */
		  delete dia;
		  break;
		} else if (code == MENU_ACCEPT){ /* Save */
			dia->save();
		} else if (code == MENU_USR1){ /* Search */
			dia->save();
			lc.attributes.delall();    /* Zero */
			lc.objectclasses.delall();
			
			char buf[100];
			sprintf(buf,"uid=%s",uid.get());
			lc.filter.setfrom(buf);
			ret = lc.search();
		} else if (code == MENU_USR2){
			dia->save();
			lc.binddn=lc.dn;
			lc.at_set("mail",mail.get());
			lc.at_set("givenname",givenname.get());
			lc.at_set("sn",sn.get());
			lc.at_set("phone",phone.get());
			lc.at_set("homephone",homephone.get());
			lc.at_set("cellphone",cellphone.get());
			lc.at_set("homeurl",homeurl.get());
			lc.at_set("telephonenumber",telephonenumber.get());
			lc.at_set("o",o.get());
			lc.at_set("ou",ou.get());
			ret = lc.modify();
		}
		delete dia;
	}
}

/* 
	Client menu 
*/
void ldap_client_menu()
{
	const char *search_tool = MSG_U(M_SEARCH_TOOL,"Search tool (devel)");
	const char *edit_tool = MSG_U(M_EDIT_TOOL,"Edit tool (devel)");
	const char *useredit_tool = MSG_U(M_USEREDIT_TOOL,"Userinfo");

	DIALOG_MENU dia;
	dia.new_menuitem("",useredit_tool);
	dia.new_menuitem("",search_tool);
	dia.new_menuitem("",edit_tool);
	int nof = 0;
	while (1){
		MENU_STATUS code = dia.editmenu (MSG_U(T_TOOL_MENU,"LDAP client tools")
			,MSG_U(I_TOOL_MENU
				,"Select a tool")
			,help_ldap
			,nof,0);
		if (code == MENU_ESCAPE || code == MENU_QUIT){
			break;
		}else{
			const char *key = dia.getmenustr(nof);
			if (key == search_tool){
				ldapsearch();
			}else if (key == edit_tool){
				ldapedit();
		        }else if (key == useredit_tool){
				ldap_useredit();
			}
		}
	}
}

/*
	LDAPsearch
*/
int ldaplist(SSTRINGS&lst,SSTRING&choice)
{
DIALOG_LISTE *dia = NULL;
		int nof = 0;
		while (1){
			if (dia == NULL){
				dia = new DIALOG_LISTE;
				int n = lst.getnb();
				dia->newf_head ("",MSG_U(F_LIST,"Result"));
				for (int i=0; i<n; i++){
					dia->new_menuitem (lst.getitem(i)->get(),"");
				}
			}
			MENU_STATUS code = dia->editmenu (MSG_U(T_LIST,"Select")
					,MSG_U(I_LIST,"Select one")
					,help_ldap
					,nof
					,MENUBUT_ADD);
			if (code == MENU_QUIT || code == MENU_ESCAPE){
				break;
			}
			else if (nof >=0 && nof < lst.getnb()){
					choice = lst.getitem(nof)->get();
					break;
			}
		}
		delete dia;
		return nof;
}






